#property indicator_chart_window //   
#property indicator_buffers 6
#property indicator_color1 Magenta // 
#property indicator_color3 Green // . . 
#property indicator_color4 Red // . . 
#property indicator_color6 Blue // . . 
//  
extern double OverSold=20; //    %% ( =100- )
extern int K=5; // %K
extern int Slow=3; // 
extern int SlowMethod=0; // 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int applied_price=0; // 0-High&Low, 1-Close&Close
extern int Border=2; //     
extern int ShowChannel=2; //  1 -   , 2 -   
extern int ShowZigZag=0; //  1 -   , 2 -   
// .
double   ZZpeak[], // 
         ZZtrough[], // 
         ChTop[], // . . 
         ChBot[], // . . 
         Stoch[]; // Stoch
double   Trend[]; //  
//  
double OverBought; //  
bool dir; // 0- , 1 - 
double max,min; //  ., 
double top,bot; // , 
int jDn,jUp; //    
double brd; //    
bool trend;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   OverBought=100.0-OverSold; //  
   brd=Border*Point; //    
//---- indicators
   SetIndexBuffer(0,ZZpeak);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Peak");
   
   SetIndexBuffer(1,ZZtrough);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Trough");
   
   if(ShowZigZag>0) {
      SetIndexStyle(0,DRAW_ZIGZAG);
      SetIndexStyle(1,DRAW_ZIGZAG);
     }
   else {      
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
     }

   SetIndexBuffer(2,ChTop);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"ChTop");

   SetIndexBuffer(3,ChBot);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"ChBot");

   if(ShowChannel>0) {
      SetIndexStyle(2,DRAW_LINE);
      SetIndexStyle(3,DRAW_LINE);
     }
   else {      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
     }

   SetIndexBuffer(4,Stoch);
   SetIndexStyle(4,DRAW_NONE);
   string _st="St("+K+", "+Slow+") "+SlowMethod+", "+applied_price;
   SetIndexLabel(4,_st);

   SetIndexBuffer(5,Trend);
   SetIndexStyle(5,DRAW_LINE,0,3);

//----
   IndicatorShortName("ZZ@Stoch"); 

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit();
   int limit=Bars-ic-1; // - 

   for(int i=limit; i>=0; i--) Stoch[i]=iStochastic(NULL,0,K,1,Slow,SlowMethod,applied_price, 0,i); 

   for(i=limit; i>0; i--)
     {
      double st=Stoch[i];
      jDn++; jUp++; //    

      bool up=st>=OverBought; // 1 -   
      bool dn=st<=OverSold; // 1 -   
      
      if(dir) { //    
         if(up) { //    
            double l=High[i]*100;
            for(int k=jUp; k>=0; k--) if(Low[i+k]<l) {int sh=i+k;l=Low[i+k];}
            bot=Low[sh]; //  = 
            if(ShowZigZag==1) ZZtrough[sh]=bot; else ZZtrough[i]=bot;
            if(ShowChannel==1) for(k=sh; k>i; k--) ChBot[k]=bot;
            dir=0; //  
           }
        }
      else {
         if(dn) {
            double h=0;
            for(k=jDn; k>=0; k--) if(High[i+k]>h) {sh=i+k; h=High[i+k];}
            top=High[sh];
            if(ShowZigZag==1) ZZpeak[sh]=top; else ZZpeak[i]=top;
            if(ShowChannel==1) for(k=sh; k>i; k--) ChTop[k]=top;
            dir=1;
           }
        }

      if(up) jUp=-2; if(dn) jDn=-2; //  

      for(k=0; k<2; k++) {ChTop[i-k]=top; ChBot[i-k]=bot;}
     }
//=============
   for(i=limit; i>=0; i--) {
      double TopBrd=ChTop[i]+brd;
      double BotBrd=ChBot[i]-brd;
      if(High[i]>TopBrd) trend=1;
      if(Low[i]<BotBrd) trend=0;

      if(trend) Trend[i]=BotBrd;
      else Trend[i]=TopBrd;
     }
        
   return(0);
  }


// -  
int reinit()
  {
   ArrayInitialize(ZZpeak,0.0);
   ArrayInitialize(ZZtrough,0.0);
   ArrayInitialize(ChTop,0.0);
   ArrayInitialize(ChBot,0.0);
   ArrayInitialize(Stoch,0.0);
   ArrayInitialize(Trend,0.0);
   dir=0;max=0;min=0;top=0;bot=0;jDn=0;jUp=0;trend=0;
   return(0);
  }

